


#include <os.h>
#include "stringHelper.h"

//inline void drawChar(unsigned char ch, int x, int y, char* scrbuf)
//{
//	// Copied from putChar, with slight modifications
//	int i, j, pixelOn;
//	for(i = 0; i < CHAR_HEIGHT; i++)
//	{
//		for(j = 0; j < CHAR_WIDTH; j++)
//		{
//			pixelOn = charMap_ascii[ch][i] << j;
//			pixelOn = pixelOn & 0x80;
//			if (pixelOn)
//			{
//				setPixelBuf(scrbuf, x + j, y + i, 0);
//			}
//			else
//			{
//				// I want the text to not force a white background
//				// setPixelBuf(scrbuf, x + j, y + i, 15);
//			}
//		}
//	}
//}
//
//void drawString(unsigned char* str, int x, int y, char* scrbuf)
//{
//	int l = strlen(str);
//	int i;
//	for (i = 0; i < l; i++)
//	{
//		if (str[i] == 0x0A)
//		{
//			x = 0;
//			y += 12;
//		}
//		else
//		{
//			drawChar(str[i], x, y, scrbuf);
//		}
//		x += 8;
//		if (x >= 312)
//		{
//			x = 0;
//			y += 12;
//		}
//	}
//}

extern inline void drawChar2(unsigned char ch, int x, int y, int textColor, int backColor, char* scrbuf)
{
	int i, j, pixelOn;
	for(i = 0; i < CHAR_WIDTH; i++)
	{
		for(j = 0; j < CHAR_HEIGHT; j++)
		{
			// I skipped the first few characters
			pixelOn = charMap[ch - 32][i] << j;
			pixelOn = pixelOn & 0x8000;
			if (pixelOn)
			{
				// 0 is black, 15 is white
				setPixelBuf(scrbuf, x + i, y + j, textColor);
			}
			else
			{
				setPixelBuf(scrbuf, x + i, y + j, backColor);
			}
		}
	}
}

extern void drawString2(unsigned char* str, int x, int y, int textColor, int backColor, char* scrbuf)
{
	int origx = x;
	int l = strlen(str);

	for(int i = 0; i < l; i++)
	{
		// Newline
		if (str[i] == 0x0A)
		{
			x = 0;
			y += 12;
		}
		else
		{
			drawChar2(str[i], x, y, textColor, backColor, scrbuf);
		}

		x = x + charSpaces[str[i] - 32] - 1;

		if (x >= 308)
		{
			x = origx;
			y = y +16;
		}
	}
}


